/*******************************************************************************
* File Name: CSN.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CSN_H) /* Pins CSN_H */
#define CY_PINS_CSN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "CSN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    CSN_Write(uint8 value) ;
void    CSN_SetDriveMode(uint8 mode) ;
uint8   CSN_ReadDataReg(void) ;
uint8   CSN_Read(void) ;
uint8   CSN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CSN_DRIVE_MODE_BITS        (3)
#define CSN_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - CSN_DRIVE_MODE_BITS))

#define CSN_DM_ALG_HIZ         (0x00u)
#define CSN_DM_DIG_HIZ         (0x01u)
#define CSN_DM_RES_UP          (0x02u)
#define CSN_DM_RES_DWN         (0x03u)
#define CSN_DM_OD_LO           (0x04u)
#define CSN_DM_OD_HI           (0x05u)
#define CSN_DM_STRONG          (0x06u)
#define CSN_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define CSN_MASK               CSN__MASK
#define CSN_SHIFT              CSN__SHIFT
#define CSN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CSN_PS                     (* (reg32 *) CSN__PS)
/* Port Configuration */
#define CSN_PC                     (* (reg32 *) CSN__PC)
/* Data Register */
#define CSN_DR                     (* (reg32 *) CSN__DR)
/* Input Buffer Disable Override */
#define CSN_INP_DIS                (* (reg32 *) CSN__PC2)


#if defined(CSN__INTSTAT)  /* Interrupt Registers */

    #define CSN_INTSTAT                (* (reg32 *) CSN__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define CSN_DRIVE_MODE_SHIFT       (0x00u)
#define CSN_DRIVE_MODE_MASK        (0x07u << CSN_DRIVE_MODE_SHIFT)


#endif /* End Pins CSN_H */


/* [] END OF FILE */
