/*******************************************************************************
* File Name: IRQ.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_IRQ_H) /* Pins IRQ_H */
#define CY_PINS_IRQ_H

#include "cytypes.h"
#include "cyfitter.h"
#include "IRQ_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    IRQ_Write(uint8 value) ;
void    IRQ_SetDriveMode(uint8 mode) ;
uint8   IRQ_ReadDataReg(void) ;
uint8   IRQ_Read(void) ;
uint8   IRQ_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define IRQ_DRIVE_MODE_BITS        (3)
#define IRQ_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - IRQ_DRIVE_MODE_BITS))

#define IRQ_DM_ALG_HIZ         (0x00u)
#define IRQ_DM_DIG_HIZ         (0x01u)
#define IRQ_DM_RES_UP          (0x02u)
#define IRQ_DM_RES_DWN         (0x03u)
#define IRQ_DM_OD_LO           (0x04u)
#define IRQ_DM_OD_HI           (0x05u)
#define IRQ_DM_STRONG          (0x06u)
#define IRQ_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define IRQ_MASK               IRQ__MASK
#define IRQ_SHIFT              IRQ__SHIFT
#define IRQ_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define IRQ_PS                     (* (reg32 *) IRQ__PS)
/* Port Configuration */
#define IRQ_PC                     (* (reg32 *) IRQ__PC)
/* Data Register */
#define IRQ_DR                     (* (reg32 *) IRQ__DR)
/* Input Buffer Disable Override */
#define IRQ_INP_DIS                (* (reg32 *) IRQ__PC2)


#if defined(IRQ__INTSTAT)  /* Interrupt Registers */

    #define IRQ_INTSTAT                (* (reg32 *) IRQ__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define IRQ_DRIVE_MODE_SHIFT       (0x00u)
#define IRQ_DRIVE_MODE_MASK        (0x07u << IRQ_DRIVE_MODE_SHIFT)


#endif /* End Pins IRQ_H */


/* [] END OF FILE */
